// Generated by CoffeeScript 1.11.1
(function() {
  var InvertedIndex;

  InvertedIndex = (function() {
    function InvertedIndex() {
      this.root = this.createNode();
      this.length = 0;
    }

    InvertedIndex.prototype.createNode = function() {
      return {
        ids: {}
      };
    };

    InvertedIndex.prototype.add = function(token, id, data, node) {
      var key, rest;
      if (node == null) {
        node = this.root;
      }
      if (!token) {
        return;
      }
      key = token.charAt(0);
      rest = token.slice(1);
      if (!(key in node)) {
        node[key] = this.createNode();
      }
      if (rest.length === 0) {
        node[key].ids[id] = data;
        this.length++;
        return void 0;
      } else {
        return this.add(rest, id, data, node[key]);
      }
    };

    InvertedIndex.prototype._getNode = function(token, node) {
      var i, j, ref;
      if (node == null) {
        node = this.root;
      }
      if (!token) {
        return null;
      }
      for (i = j = 0, ref = token.length; 0 <= ref ? j < ref : j > ref; i = 0 <= ref ? ++j : --j) {
        if (!(token.charAt(i) in node)) {
          return null;
        }
        node = node[token.charAt(i)];
      }
      return node;
    };

    InvertedIndex.prototype.has = function(token) {
      return (this._getNode(token)) != null;
    };

    InvertedIndex.prototype.getNode = function(token) {
      return this._getNode(token) || {};
    };

    InvertedIndex.prototype.get = function(token, node) {
      return (this._getNode(token, node) || {}).ids || {};
    };

    InvertedIndex.prototype.count = function(token, node) {
      return Object.keys(this.get(token, node)).length;
    };

    InvertedIndex.prototype.remove = function(token, id, node) {
      if (node == null) {
        node = this.root;
      }
      node = this._getNode(token, node);
      if (!node) {
        return;
      }
      return delete node.ids[id];
    };

    InvertedIndex.prototype.expand = function(token, memo) {
      var k, node;
      if (memo == null) {
        memo = [];
      }
      node = this.getNode(token);
      for (k in node.ids || {}) {
        memo.push(token);
        break;
      }
      for (k in node) {
        if (k !== 'docs') {
          this.expand(token + k, memo);
        }
      }
      return memo;
    };

    return InvertedIndex;

  })();

  module.exports = InvertedIndex;

}).call(this);
