// Generated by CoffeeScript 1.11.1
(function() {
  var SortedSet;

  SortedSet = (function() {
    function SortedSet() {
      this.elements = [];
    }

    SortedSet.prototype.add = function() {
      var elt, i, k, ref;
      for (i = k = 0, ref = arguments.length; 0 <= ref ? k < ref : k > ref; i = 0 <= ref ? ++k : --k) {
        elt = arguments[i];
        if (~this.indexOf(elt)) {
          continue;
        }
        this.elements.splice(this.locationFor(elt), 0, elt);
      }
      return void 0;
    };

    SortedSet.prototype.toArray = function() {
      return this.elements.slice();
    };

    SortedSet.prototype.map = function() {
      return this.elements.map.apply(this.elements, arguments);
    };

    SortedSet.prototype.foreach = function() {
      return this.elements.foreach.apply(this.elements, arguments);
    };

    SortedSet.prototype.indexOf = function(elem) {
      var end, pivot, pivotElem, sectionLength, start;
      start = 0;
      end = this.elements.length;
      sectionLength = end - start;
      pivot = start + Math.floor(sectionLength / 2);
      pivotElem = this.elements[pivot];
      while (sectionLength > 1) {
        if (pivotElem === elem) {
          return pivot;
        }
        if (pivotElem < elem) {
          start = pivot;
        }
        if (pivotElem > elem) {
          end = pivot;
        }
        sectionLength = end - start;
        pivot = start + Math.floor(sectionLength / 2);
        pivotElem = this.elements[pivot];
      }
      if (pivotElem === elem) {
        return pivot;
      } else {
        return -1;
      }
    };

    SortedSet.prototype.locationFor = function(elem) {
      var end, pivot, pivotElem, sectionLength, start;
      start = 0;
      end = this.elements.length;
      sectionLength = end - start;
      pivot = start + Math.floor(sectionLength / 2);
      pivotElem = this.elements[pivot];
      while (sectionLength > 1) {
        if (pivotElem < elem) {
          start = pivot;
        }
        if (pivotElem > elem) {
          end = pivot;
        }
        sectionLength = end - start;
        pivot = start + Math.floor(sectionLength / 2);
        pivotElem = this.elements[pivot];
      }
      if (pivotElem > elem) {
        return pivot;
      } else {
        return pivot + 1;
      }
    };

    SortedSet.prototype.intersect = function(otherSet) {
      var a, a_len, b, b_len, i, intersection, j;
      intersection = new SortedSet;
      i = 0;
      j = 0;
      a_len = this.length;
      b_len = otherSet.length;
      a = this.elements;
      b = otherSet.elements;
      while (true) {
        if ((i > a_len - 1) || (j > b_len - 1)) {
          break;
        }
        if (a[i] === b[j]) {
          intersection.add(a[i]);
          i++;
          j++;
          continue;
        }
        if (a[i] < b[j]) {
          i++;
          continue;
        }
        if (a[i] > b[j]) {
          j++;
          continue;
        }
      }
      return intersection;
    };

    SortedSet.prototype.clone = function() {
      var cl;
      cl = new SortedSet;
      cl.elements = this.toArray();
      return cl;
    };

    SortedSet.prototype.union = function(otherSet) {
      var i, k, longSet, ref, shortSet, unionSet;
      if (this.length >= otherSet.length) {
        longSet = this;
        shortSet = otherSet;
      } else {
        longSet = otherSet;
        shortSet = this;
      }
      unionSet = longSet.clone();
      for (i = k = 0, ref = shortSet.elements.length; 0 <= ref ? k < ref : k > ref; i = 0 <= ref ? ++k : --k) {
        unionSet.add(shortSet.elements[i]);
      }
      return unionSet;
    };

    SortedSet.prototype.toJSON = function() {
      return this.toArray();
    };

    return SortedSet;

  })();

  Object.defineProperty(SortedSet.prototype, 'length', {
    enumerable: true,
    configurable: false,
    get: function() {
      return this.elements.length;
    }
  });

  module.exports = SortedSet;

}).call(this);
