// Generated by CoffeeScript 1.11.1
(function() {
  var Node, SparseVector;

  Node = (function() {
    function Node(idx1, val1, next1) {
      this.idx = idx1;
      this.val = val1;
      this.next = next1;
    }

    return Node;

  })();

  SparseVector = (function() {
    function SparseVector() {
      this._magnitude = void 0;
      this.list = void 0;
      this.length = 0;
    }

    SparseVector.prototype.insert = function(idx, val) {
      var list, next, prev;
      this._magnitude = void 0;
      list = this.list;
      if ((!list) || (idx < list.idx)) {
        this.list = new Node(idx, val, list);
        return this.length++;
      }
      prev = list;
      next = list.next;
      while (next) {
        if (idx < next.idx) {
          prev.next = new Node(idx, val, next);
          return this.length++;
        }
        prev = next;
        next = next.next;
      }
      prev.next = new Node(idx, val, next);
      return this.length++;
    };

    SparseVector.prototype.magnitude = function() {
      var accum, node;
      if (this._magnitude) {
        return this._magnitude;
      }
      node = this.list;
      accum = 0;
      while (node) {
        accum += node.val * node.val;
        node = node.next;
      }
      return this._magnitude = Math.sqrt(accum);
    };

    SparseVector.prototype.dot = function(other) {
      var dotProduct, node, otherNode;
      node = this.list;
      otherNode = other.list;
      dotProduct = 0;
      while (node && otherNode) {
        if (node.idx < otherNode.idx) {
          node = node.next;
        } else if (node.idx > otherNode.idx) {
          otherNode = otherNode.next;
        } else {
          dotProduct += node.val * otherNode.val;
          node = node.next;
          otherNode = otherNode.next;
        }
      }
      return dotProduct;
    };

    SparseVector.prototype.similarity = function(other) {
      return this.dot(other) / (this.magnitude() * other.magnitude());
    };

    return SparseVector;

  })();

  module.exports = SparseVector;

}).call(this);
