// Generated by CoffeeScript 1.11.1
(function() {
  var TokenPipeline;

  TokenPipeline = (function() {
    function TokenPipeline() {
      this.stages = [];
    }

    TokenPipeline.prototype.addStage = function(stage) {
      return this.stages.push(stage);
    };

    TokenPipeline.prototype.run = function(tokenStream) {
      var i, j, len, len1, nextTokenStream, ref, result, stage, token;
      ref = this.stages;
      for (i = 0, len = ref.length; i < len; i++) {
        stage = ref[i];
        stage.willRun(this);
        nextTokenStream = [];
        for (j = 0, len1 = tokenStream.length; j < len1; j++) {
          token = tokenStream[j];
          result = stage.run(token);
          if (result != null) {
            if (Array.isArray(result)) {
              nextTokenStream = nextTokenStream.concat(result);
            } else {
              nextTokenStream.push(result);
            }
          }
        }
        tokenStream = nextTokenStream;
      }
      return tokenStream;
    };

    return TokenPipeline;

  })();

  module.exports = TokenPipeline;

}).call(this);
